## Intel Thermal Rf service

Intel Thermal Rf service — Support for the Intel Thermal Rf service.

## Functions

void | mbim_intel_rfim_frequency_value_array_free ()
MbimMessage * | mbim_message_intel_thermal_rf_rfim_query_new ()
MbimMessage * | mbim_message_intel_thermal_rf_rfim_set_new ()
gboolean | mbim_message_intel_thermal_rf_rfim_response_parse ()
gboolean | mbim_message_intel_thermal_rf_rfim_notification_parse ()

## Types and Values

| MbimIntelRfimFrequencyValue
typedef | MbimIntelRfimFrequencyValueArray

## Description

This section implements support for requests, responses and notifications in the Intel Thermal Rf service.

## Functions

### mbim_intel_rfim_frequency_value_array_free ()

    void
    mbim_intel_rfim_frequency_value_array_free
                                   (MbimIntelRfimFrequencyValueArray *array);

Frees the memory allocated for the array of MbimIntelRfimFrequencyValue structs.

#### Parameters

array | a NULL terminated array of MbimIntelRfimFrequencyValue structs. |

Since: 1.28

### mbim_message_intel_thermal_rf_rfim_query_new ()

    MbimMessage *
    mbim_message_intel_thermal_rf_rfim_query_new
                                   (GError **error);

Create a new request for the 'RFIM' query command in the 'Intel Thermal RF' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_intel_thermal_rf_rfim_set_new ()

    MbimMessage *
    mbim_message_intel_thermal_rf_rfim_set_new
                                   (gboolean activation_state,
                                    GError **error);

Create a new request for the 'RFIM' set command in the 'Intel Thermal RF' service.

#### Parameters

activation_state | the 'ActivationState' field, given as a gboolean. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_intel_thermal_rf_rfim_response_parse ()

    gboolean
    mbim_message_intel_thermal_rf_rfim_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_rfim_frequency_values_count,
                                    MbimIntelRfimFrequencyValueArray **out_rfim_frequency_values,
                                    GError **error);

Parses and returns parameters of the 'RFIM' response command in the 'Intel Thermal RF' service.

#### Parameters

message | the MbimMessage. |
out_rfim_frequency_values_count | return location for a guint32, or `NULL` if the 'RfimFrequencyValuesCount' field is not needed. | [out][optional][transfer none]
out_rfim_frequency_values | return location for a newly allocated array of MbimIntelRfimFrequencyValue items, or `NULL` if the 'RfimFrequencyValues' field is not needed. Free the returned value with `mbim_intel_rfim_frequency_value_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimIntelRfimFrequencyValue]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_intel_thermal_rf_rfim_notification_parse ()

    gboolean
    mbim_message_intel_thermal_rf_rfim_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_rfim_frequency_values_count,
                                    MbimIntelRfimFrequencyValueArray **out_rfim_frequency_values,
                                    GError **error);

Parses and returns parameters of the 'RFIM' notification command in the 'Intel Thermal RF' service.

#### Parameters

message | the MbimMessage. |
out_rfim_frequency_values_count | return location for a guint32, or `NULL` if the 'RfimFrequencyValuesCount' field is not needed. | [out][optional][transfer none]
out_rfim_frequency_values | return location for a newly allocated array of MbimIntelRfimFrequencyValue items, or `NULL` if the 'RfimFrequencyValues' field is not needed. Free the returned value with `mbim_intel_rfim_frequency_value_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimIntelRfimFrequencyValue]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

## Types and Values

### MbimIntelRfimFrequencyValue

    typedef struct {
        guint32 serving_cell_info;
        guint64 center_frequency;
        guint32 bandwidth;
        guint32 rsrp;
        guint32 rsrq;
        guint32 sinr;
        guint32 rssi;
        guint32 connection_status;
    } MbimIntelRfimFrequencyValue;

A MbimIntelRfimFrequencyValue element.

#### Members

guint32 `serving_cell_info`; | a MbimIntelServingCellInfo given as a guint32. |
guint64 `center_frequency`; | a guint64. |
guint32 `bandwidth`; | a guint32. |
guint32 `rsrp`; | a guint32. |
guint32 `rsrq`; | a guint32. |
guint32 `sinr`; | a guint32. |
guint32 `rssi`; | a guint32. |
guint32 `connection_status`; | a gboolean given as a guint32. |

Since: 1.28

### MbimIntelRfimFrequencyValueArray

    typedef MbimIntelRfimFrequencyValue *MbimIntelRfimFrequencyValueArray;

A NULL-terminated array of MbimIntelRfimFrequencyValue elements.

Since: 1.28